import time, sys
from rgbmatrix import RGBMatrix, RGBMatrixOptions
from PIL import Image

options = RGBMatrixOptions()
options.cols = 64
options.rows = 64
options.parallel = 1
options.gpio_slowdown = 3
options.drop_privileges=False

gifFileName = "converted.gif"
gif = Image.open(gifFileName)
try:
    num_frames = gif.n_frames
    print("Finished reading a gif.")
except Exception:
    sys.exit("provided image is not a gif")

matrix = RGBMatrix(options = options)

canvases = []
print("Preprocessing gif...")
for frame_index in range(0, num_frames):
    gif.seek(frame_index)
    frame = gif.copy()
    frame.thumbnail((matrix.width, matrix.height), Image.ANTIALIAS)
    canvas = matrix.CreateFrameCanvas()
    canvas.SetImage(frame.convert("RGB"))
    canvases.append(canvas)
gif.close()
print("Completed Preprocessing. Displaying gif")

try:
    print("Press Ctrl-C to stop.")

    # Infinitely loop through the gif
    cur_frame = 0
    while(True):
        matrix.SwapOnVSync(canvases[cur_frame], framerate_fraction=10)
        if cur_frame == num_frames - 1:
            cur_frame = 0
        else:
            cur_frame += 1
except KeyboardInterrupt:
    sys.exit(0)
